/* File modClient.cpp */
/*
 ##############################################################
 # (C) 2015 BAE SYSTEMS
 #
 # ECOA GimmeGimmeGimme (Client-Server) C++ Sample
 #
 # $Id: modClient.cpp,v 2.2 2017/11/06 15:33:27 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE SYSTEMS,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE SYSTEMS, Dassault Aviation,
 # Bull SAS, Thales Systemes Aeroportes,  Limited,
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software code was developed by BAE Systems (Operations)
 # Limited, Electronic Systems and is the Foreground Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/
#include "modClient.hpp"
#include <stdio.h>

namespace modClient
{

extern "C" {

   Module* modClient__new_instance()
   {
      return new Module();
   }
}

/* Runtime lifecycle API */
void Module::INITIALIZE__received
   ()
{
   /* User Code Here */
}

void Module::START__received
   ()
{
	printf( "Client started...\n" );
}

void Module::STOP__received
   ()
{
   /* User Code Here */
}

void Module::SHUTDOWN__received
   ()
{
   /* User Code Here */
}

void Module::Tick__received
   ()
{
	ECOA::int32 IAm;
	ECOA::return_status errc;
	sql::string requestStmt, responseData;
	//
	this->container->get_Id_value( /*&*/IAm );
	//
	requestStmt.current_size = sprintf( requestStmt.data, "select * from iTable where %c = %d;", (IAm==1?'A':'B'), this->user.Count++ );
	printf( "Request: %s\n", requestStmt.data );
	errc = this->container->Gimme__request_sync( requestStmt, responseData );
	if( errc != ECOA::return_status::OK ){
		printf( "Gimme request failed with errc = %ld\n", (long)errc );
	}else{
		responseData.data[responseData.current_size] = '\000'; // responseData is NOT zero terminated...
		printf( "Response: %s\n", responseData.data );
	}
}

} /* modClient */
