/*
 * @file modClient.hpp
 * Module Interface class header for Module modClient
 * The user shall write this concrete class corresponding to the
 * Module Implementation itself.
 */

#if !defined(MODCLIENT_HPP)
#define MODCLIENT_HPP

#include "modClient_user_context.hpp"
#include "modClient_container.hpp"

#include "ECOA.hpp"

#include "sql.hpp"


namespace modClient
{
   class Module
   {

      public:

      /* Runtime lifecycle API */
      void INITIALIZE__received
         ();

      void START__received
         ();

      void STOP__received
         ();

      void SHUTDOWN__received
         ();

      // the Container pointer
      Container* container;

      // user data (which does not belong to the warm start context) for this
      // module implementation must be declared here within a standard structure:
      user_context user;

      // All the operations for this Module implementation will be
      // declared as public concrete methods here


      void Tick__received
         ();


   }; /* Module */

   extern "C" {

      Module* modClient__new_instance();

   }

} /* modClient */

#endif  /* MODCLIENT_HPP */

