/* File modServer.cpp */
/*
 ##############################################################
 # (C) 2015 BAE SYSTEMS
 #
 # ECOA GimmeGimmeGimme (Client-Server) C++ Sample
 #
 # $Id: modServer.cpp,v 2.2 2017/11/06 15:33:27 ksappleb Exp $
 #
 # Part of the BAE Systems, Rochester, ECOA Samples collection
 #
 # Created by K S Appleby, BAE Systems, Airport Works, Rochester, Kent
 #
 # This software is developed for and on behalf of BAE SYSTEMS,
 # Dassault Aviation, Bull SAS, Thales Systemes Aeroportes,
 # GE Aviation Systems Limited,
 # General Dynamics United Kingdom Limited and Leonardo MW Ltd,
 # and the copyright is owned by BAE SYSTEMS, Dassault Aviation,
 # Bull SAS, Thales Systemes Aeroportes,  Limited,
 # GE Aviation Systems Limited, General Dynamics United Kingdom
 # Limited and Leonardo MW Ltd
 #
 # This software code was developed by BAE Systems (Operations)
 # Limited, Electronic Systems and is the Foreground Intellectual
 # Property of BAE Systems (Operations) Limited, Electronic Systems.
 #
 # The information set out in this document is provided solely
 # on an 'as is' basis and the co-developers of this software make
 # no warranties expressed or implied, including no warranties
 # as to completeness, accuracy or fitness for purpose, with respect
 # to any of the information.
 ##############################################################
*/
#include "modServer.hpp"
#include <stdio.h>

namespace modServer
{

extern "C" {

   Module* modServer__new_instance()
   {
      return new Module();
   }
}


      /* Runtime lifecycle API */
void Module::INITIALIZE__received
   ()
{
	this->user.count = 0;
}

void Module::START__received
   ()
{
	printf( "Server is running...\n" );
}

void Module::STOP__received
   ()
{
   /* User Code Here */
}

void Module::SHUTDOWN__received
   ()
{
   /* User Code Here */
}

void Module::Gimme__request_received
   (const ECOA::uint32 ID,
          const sql::string &statement)
{
	ECOA::char8 src;
	ECOA::int32 value;
	sql::string data;
	//
	// For now, respond any old rubbish... ish.
	sscanf( statement.data, "select * from iTable where %c = %d", &src, &value );
	data.current_size = sprintf( data.data, "%c[%d]: %d", src, value, this->user.count++ );
	this->container->Gimme__response_send( ID, data );
}


} /* modServer */
