/*
 * @file modServer.hpp
 * Module Interface class header for Module modServer
 * The user shall write this concrete class corresponding to the
 * Module Implementation itself.
 */

#if !defined(MODSERVER_HPP)
#define MODSERVER_HPP

#include "modServer_user_context.hpp"
#include "modServer_container.hpp"

#include "ECOA.hpp"

#include "sql.hpp"


namespace modServer
{
   class Module
   {

      public:

      /* Runtime lifecycle API */
      void INITIALIZE__received
         ();

      void START__received
         ();

      void STOP__received
         ();

      void SHUTDOWN__received
         ();

      // the Container pointer
      Container* container;

      // user data (which does not belong to the warm start context) for this
      // module implementation must be declared here within a standard structure:
      user_context user;

      // All the operations for this Module implementation will be
      // declared as public concrete methods here


      void Gimme__request_received
         (const ECOA::uint32 ID,
          const sql::string &statement);


   }; /* Module */

   extern "C" {

      Module* modServer__new_instance();

   }

} /* modServer */

#endif  /* MODSERVER_HPP */

