/*
 * @file modServer_container.hpp
 * Container Interface class header for Module modServer
 * Generated automatically from specification; do not modify here
 */
#if !defined(MODSERVER_CONTAINER_HPP)
#define MODSERVER_CONTAINER_HPP


/* Include the types from the XML types files */
#include "ECOA.hpp"

#include "sql.hpp"


namespace modServer
{
   class Container
   {

      public:


      /* Logging and fault management services API */
      void log_trace
         (const ECOA::log &log);


      void log_debug
         (const ECOA::log &log);


      void log_info
         (const ECOA::log &log);


      void log_warning
         (const ECOA::log &log);


      void raise_error
         (const ECOA::log &log);


      void raise_fatal_error
         (const ECOA::log &log);


      /* Time services API */
      void get_relative_local_time
         (ECOA::hr_time &relative_local_time);


      ECOA::return_status get_UTC_time
         (ECOA::global_time &utc_time);


      ECOA::return_status get_absolute_system_time
         (ECOA::global_time &absolute_system_time);


      /* Time resolution services API */
      void get_relative_local_time_resolution
         (ECOA::duration &relative_local_time_resolution);


      void get_UTC_time_resolution
         (ECOA::duration &utc_time_resolution);


      void get_absolute_system_time_resolution
         (ECOA::duration &absolute_system_time_resolution);


      ECOA::return_status Gimme__response_send
         (const ECOA::uint32 ID,
          const sql::string &data);



         // Other container technical data will accessible through the incomplete
         // structure defined here:
         struct platform_hook;

         // The constructor of the Container shall have the following signature:
         Container(platform_hook* hook);

      private:
         // private data for this container implementation is declared as a
         // private struct within the implementation
         platform_hook *hook;

   }; /* Container */
} /* modServer */

#endif  /* MODSERVER_CONTAINER_HPP */

